
# conditional build:
# _with_lfs - enable LFS support (requires patched 2.2 or 2.4 kernel)

Summary:	C library optimized for size
Name:		uClibc
Version:	0.9.9
Release:	2mdk
License:	LGPL
Group:		System/Libraries
Source0:	http://uclibc.org/downloads/%{name}-%{version}.tar.bz2
Patch0:		%{name}-Makefile.patch.bz2
Patch1:		%{name}-lfs.patch.bz2
Patch2:		%{name}-no_bogus_gai.patch.bz2
Patch3:		%{name}-no_hardcoded_gcc.patch.bz2
URL:		http://uclibc.org/
BuildRequires:	which
BuildRequires:	kernel-source
Requires:	binutils gcc-cpp
BuildRoot:	%{_tmppath}/%{name}-%{version}-root

%description
Small libc for building embedded applications.

%package devel
Summary:	Development files for uClibc
Group:		Development/C
Requires:	%{name} = %{version}
Requires:	binutils
Requires:	gcc

%description devel
Small libc for building embedded applications.

%package static-devel
Summary:	Static uClibc libratries
Group:		Development/C
Requires:	%{name}-devel = %{version}
Provides:	libc-static

%description static-devel
Static uClibc libratries.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1

%ifarch %{ix86}
ln -sf extra/Configs/Config.i386 Config
%endif
%ifarch sparc sparc64
ln -sf extra/Configs/Config.sparc Config
%endif
%ifarch alpha
ln -sf extra/Configs/Config.alpha Config
%endif
%ifarch ppc ppc64
ln -sf extra/Configs/Config.powerpc Config
%endif

%build
cat Config > Config.tmp

sed -e 's/^HAVE_SHARED *=.*$/HAVE_SHARED = true/;
	s/^INCLUDE_RPC *=.*$/INCLUDE_RPC = true/;
	s/^SYSTEM_DEVEL_PREFIX *=.*$/SYSTEM_DEVEL_PREFIX = \$\(DEVEL_PREFIX\)\/usr/;
%if %{?_with_lfs:1}%{!?_with_lfs:0}
	s/^DOLFS *=.*$/DOLFS = true/;
%endif
	s/^INCLUDE_IPV6 *=.*$/INCLUDE_IPV6 = true/;
	s/^DO_C99_MATH *=.*$/DO_C99_MATH = true/' Config.tmp > Config

%{__make} \
%ifarch ppc
	TARGET_ARCH="powerpc" \
%else
	TARGET_ARCH="%{_arch}" \
%endif
	KERNEL_SOURCE=%{_prefix}/src/linux \
	NATIVE_CC=%{__cc} \
	NATIVE_CFLAGS="%{optflags}" \
	OPTIMIZATION="%{optflags} -Os"

%install
rm -rf %{buildroot}
install -d %{buildroot}%{_bindir}
install -d %{buildroot}%{_includedir}

%{__make} install \
	NATIVE_CC=%{__cc} \
	NATIVE_CFLAGS="%{optflags}" \
	TARGET_ARCH="%{_arch}" \
	PREFIX=%{buildroot}

%ifarch ppc
ln -sf ppc-linux-uclibc %{buildroot}%{_prefix}/powerpc-linux-uclibc
%endif

# these links are *needed* (by stuff in bin/)
for f in %{buildroot}%{_prefix}/%{_arch}-linux-uclibc%{_bindir}/* ; do
	mv $f %{buildroot}%{_bindir}
	ln -sf ../../../bin/`basename $f` $f
done

find %{buildroot}%{_prefix}/%{_arch}-linux-uclibc/include -name CVS | xargs rm -rf

# OE: don't ship these?
#rm -rf %{buildroot}%{_prefix}/%{_arch}-linux-uclibc/include/linux
#ln -snf ../../include/linux %{buildroot}%{_prefix}/%{_arch}-linux-uclibc/include/linux 
#rm -rf %{buildroot}%{_prefix}/%{_arch}-linux-uclibc/include/asm-%{_arch}
#ln -snf ../../include/asm %{buildroot}%{_prefix}/%{_arch}-linux-uclibc/include/asm

# at least nuke this one...
rm -rf %{buildroot}%{_prefix}/%{_arch}-linux-uclibc/include/linux/modules

%clean
rm -rf %{buildroot}

%files
%defattr(644,root,root,755)
%doc README
%dir %{_prefix}/%{_arch}-linux-uclibc
%dir %{_prefix}/%{_arch}-linux-uclibc/lib
%ifnarch sparc sparc64
%attr(755,root,root) %{_prefix}/%{_arch}-linux-uclibc/lib/ld-*
%endif
%attr(755,root,root) %{_prefix}/%{_arch}-linux-uclibc/lib/lib*%{version}.so
%attr(755,root,root) %{_prefix}/%{_arch}-linux-uclibc/lib/lib*.so.0
%ifarch ppc
%{_prefix}/powerpc-linux-uclibc
%endif

%files devel
%defattr(644,root,root,755)
%doc docs/* docs/uclibc.org/*.html COPYING.LIB Changelog TODO
%attr(755,root,root) %{_bindir}/*
%dir %{_prefix}/%{_arch}-linux-uclibc/bin
%attr(755,root,root) %{_prefix}/%{_arch}-linux-uclibc/bin/*
%{_prefix}/%{_arch}-linux-uclibc/usr
%{_prefix}/%{_arch}-linux-uclibc/lib/crt0.o
%attr(755,root,root) %{_prefix}/%{_arch}-linux-uclibc/lib/libc.so
%attr(755,root,root) %{_prefix}/%{_arch}-linux-uclibc/lib/libcrypt.so
%ifnarch sparc sparc64
%attr(755,root,root) %{_prefix}/%{_arch}-linux-uclibc/lib/libdl.so
%endif
%attr(2755,root,root) %{_prefix}/%{_arch}-linux-uclibc/lib/libm.so
%attr(755,root,root) %{_prefix}/%{_arch}-linux-uclibc/lib/libresolv.so
%attr(755,root,root) %{_prefix}/%{_arch}-linux-uclibc/lib/libutil.so
%{_prefix}/%{_arch}-linux-uclibc/include

%files static-devel
%defattr(644,root,root,755)
%{_prefix}/%{_arch}-linux-uclibc/lib/lib*.a

%changelog
* Thu Jan 16 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.9.9-2mdk
- misc spec file fixes

* Tue Sep 24 2002 Oden Eriksson <oden.eriksson@kvikkjokk.net> 0.9.9-1mdk
- initial cooker contrib, ripped from PLD, adapted for ML


